package types

// Code generated by github.com/CovenantSQL/HashStablePack DO NOT EDIT.

import (
	"bytes"
	"crypto/rand"
	"encoding/binary"
	"testing"
)

func TestMarshalHasholdverUpdateBillingHeader(t *testing.T) {
	v := UpdateBillingHeader{}
	binary.Read(rand.Reader, binary.BigEndian, &v)
	bts1, err := v.MarshalHasholdver()
	if err != nil {
		t.Fatal(err)
	}
	bts2, err := v.MarshalHasholdver()
	if err != nil {
		t.Fatal(err)
	}
	if !bytes.Equal(bts1, bts2) {
		t.Fatal("hash not stable")
	}
}

func BenchmarkMarshalHasholdverUpdateBillingHeader(b *testing.B) {
	v := UpdateBillingHeader{}
	b.ReportAllocs()
	b.ResetTimer()
	for i := 0; i < b.N; i++ {
		v.MarshalHasholdver()
	}
}

func BenchmarkAppendMsgoldverUpdateBillingHeader(b *testing.B) {
	v := UpdateBillingHeader{}
	bts := make([]byte, 0, v.Msgsizeoldver())
	bts, _ = v.MarshalHasholdver()
	b.SetBytes(int64(len(bts)))
	b.ReportAllocs()
	b.ResetTimer()
	for i := 0; i < b.N; i++ {
		bts, _ = v.MarshalHasholdver()
	}
}
